fens = [fenode(struct('id', 1,'xyz', [0, 0]));...
   fenode(struct('id', 2,'xyz', [ 4, 0]));...
   fenode(struct('id', 3,'xyz', [ 8, 0]));...
   fenode(struct('id', 4,'xyz', [ 8, 6]));...
   fenode(struct('id', 5,'xyz', [4, 6]));...
   fenode(struct('id', 6,'xyz', [0, 6]));...
   fenode(struct('id', 7,'xyz', [ 4, 3]))
    ];
gcells=[gcell_T3(struct('id',1,'conn',[1,2,7]));...
    gcell_T3(struct('id',2,'conn',[2,3,7]));...
    gcell_T3(struct('id',3,'conn',[ 3, 4,7]));...
    gcell_T3(struct('id',4,'conn',[ 7, 4, 5]));...
    gcell_T3(struct('id',5,'conn',[7, 5, 6])); ...
    gcell_T3(struct('id',6,'conn',[1, 7, 6]))]
drawmesh({fens,gcells},'gcells','nodes','shrink', 0.8);
view(2)
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
xy=get(geom,'values')
% z=xy(:,1)*0.2+xy(:,2).*xy(:,1)*0.2+0.01*xy(:,2).^2;
% z=3*xy(:,1)-5*xy(:,2)+3;
% z=3*xy(:,1)-5*xy(:,2)+3;
z=0.5 *xy(:,1).^2-0.1 *xy(:,2).^3;
geom3 = field(struct ('name', ['geom3'],  'data',[xy, z/10]));
gv=graphic_viewer;
gv=reset (gv,[]);
for i=1:length (gcells)
    draw(gcells(i), gv, struct ('x',geom3, 'u',0*geom3,...
        'facecolor','red','edgecolor','none', 'shrink',1));
    draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, ...
        'facecolor','none'));
end
headlight( gv)
gv=rotate (gv);

[fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
        'curve 1  line   0 0 8 0',...
        'curve 2  line   8 0 8 6 ',...
        'curve 3  line   8 6 0 6',...
        'curve 4  line   0 6 0 0',...
        'subregion 1  property 1 boundary 1 2 3 4',...
        ['m-ctl-point constant ' num2str(0.35)]
        }, 1.0);
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
xy=get(geom,'values');
% z=xy(:,1)*0.2+xy(:,2).*xy(:,1)*0.2+0.01*xy(:,2).^2;
% z=3*xy(:,1)-5*xy(:,2)+3;
% z=3*xy(:,1)-5*xy(:,2)+3;
z=0.5 *xy(:,1).^2-0.1 *xy(:,2).^3;
geom3 = field(struct ('name', ['geom3'],  'data',[xy, z/10]));
for i=1:length (gcells)
    draw(gcells(i), gv, struct ('x',geom3, 'u',0*geom3,...
        'facecolor','yellow','edgecolor','none', 'shrink',1));
%     draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, ...
%         'facecolor','none'));
end

